/* 
 * x-tlk Toolkit - Copyright (c) Holger Pfaff
 * http://pfaff.dnsalias.net
 *
 * This software maybe used for any purpose provided the
 * above copyright notice is retained. It is supplied as is.
 * No warranty expressed or implied - Use at your own risk.
 */

#ifndef _Dbk_h
#define _Dbk_h

#ifdef _Dbk_c

int Dbk_off;
int Dbk_len;
int Dbk_rev = 1;
char *Dbk_err_rdonly = "[1] readonly dbk";
char *Dbk_err_nofile = "[0] no filename";

#define Dbk_set(dbk, where, what) (void) memcpy(where, what, ((Dbk)dbk)->recl)

#else
#endif /*_Dbk_c*/

/* Public */

Dbk   Dbk_create();    /* Create empty memory database  */
void  Dbk_destroy();   /* Destroys database, NO SAVE !  */
int   Dbk_load();      /* Append data from file, -1=err */
Dbk   Dbk_update();    /* update  from newer datafile   */
int   Dbk_save();      /* Store database to file,-1=err */
int   Dbk_sortkey();   /* Sort with specific key/keylen */
int   Dbk_put();       /* insert/replace record ,-1=err */
char *Dbk_getrec();    /* get record by number          */
char *Dbk_getkey();    /* get record by key, off, len   */
int   Dbk_del();       /* delete record by key ,-1=err  */
int   Dbk_delrec();    /* delete record by number,-1=err*/
void  Dbk_sortparms(); /* change sortparams             */
int   Dbk_recno();     /* returns record# by key or -1  */
void  Dbk_delobsolete();/* del obsolete backup files    */

/* Private */

int   Dbk_new();       /* append empty record and set   */
int   Dbk_free();      /* free one record, -1=err       */
int   Dbk_cmp();       /* Internal compare function     */
long  Dbk_mtime();     /* return lastmod. time of file  */
void  Dbk_errproc();   /* Calls user errproc or stderr  */
void  Dbk_chkch();     /* Checks if saveop has completed*/
int   Dbk_write();     /* actually writes db-file       */

/*
 * DEFINES (Tlk.h/Dbk.h)
 * 
 * Dbk_getflag()       * returns value of flag         
 * Dbk_setflag()       * set flag to 1                 
 * Dbk_unsetflag()     * set flag to 0                 
 * Dbk_sort()          * sort db with predefined key   
 * Dbk_cnt()           * return number of records      
 * Dbk_set();          * copy data into record         
 * Dbk_get();          * get record by key         
 */

#endif  /*_Dbk_h*/
