/* 
 * x-tlk Toolkit - Copyright (c) Holger Pfaff
 * http://pfaff.dnsalias.net
 *
 * This software maybe used for any purpose provided the
 * above copyright notice is retained. It is supplied as is.
 * No warranty expressed or implied - Use at your own risk.
 */

#ifndef _Dsp_h
#define _Dsp_h

#define DSP_FONT_CNT        9
#define DSP_SYSTEM_SCALE    2
#define DSP_FONT_NOT_AVAIL -1
#define DSP_COLORFACTOR     1.20
#define DSP_DEFAULT_COLOR  "grey70"


#ifdef _Dsp_c

Display   *Dsp;

char *Dsp_fn[DSP_FONT_CNT] = { "5x8", "6x10", "6x13", "7x14", "8x16", "9x15", "10x20", "12x24", ""};

int   Dsp_is_ow;
int   Dsp_kbdtype = 0;
int   Dsp_screen;
int   Dsp_color;
int   Dsp_depth;
int   Dsp_slow = FALSE;
int   Dsp_default_scale;

unsigned char Dsp_gray25b[2] = {0x41, 0x40};
unsigned char Dsp_gray50b[2] = {0x55, 0x56};
unsigned char Dsp_gray75b[2] = {0xff, 0xfd};

int   Dsp_fd[DSP_FONT_CNT];   /* Font Descent  */
int   Dsp_rw[DSP_FONT_CNT];   /* Raster Width  */
int   Dsp_rh[DSP_FONT_CNT];   /* Raster Height */
int   Dsp_ul[DSP_FONT_CNT];   /* UmlautFlag    */
Font  Dsp_ft[DSP_FONT_CNT];   /* Font ID       */

char *Dsp_name    = "";
char *Dsp_prog    = "XTOOL";
char *Dsp_colname = DSP_DEFAULT_COLOR;

long  Dsp_grey25;
long  Dsp_grey50;
long  Dsp_grey75;
long  Dsp_white;
long  Dsp_black;

GC    Dspgc_clr;
GC    Dspgc_inv;
GC    Dspgc_dbl;
GC    Dspgc_25;
GC    Dspgc_50;
GC    Dspgc_75;
GC    Dspgc = 0;

XrmDatabase Dsp_DB = NULL;
Window      Dsp_root;
Cursor      Dspcur[6];

#else

extern Display   *Dsp;

extern XrmDatabase Dsp_DB;
extern Window      Dsp_root;
extern Cursor      Dspcur[];

extern int   Dsp_fd[];
extern int   Dsp_rw[];
extern int   Dsp_rh[];
extern int   Dsp_ul[];
extern Font  Dsp_ft[];

extern char *Dsp_fn[];
extern char *Dsp_name;
extern char *Dsp_prog;
extern char *Dsp_colname;

extern int   Dsp_is_ow;
extern int   Dsp_kbdtype;
extern int   Dsp_screen;
extern int   Dsp_color;
extern int   Dsp_depth;
extern int   Dsp_slow;
extern int   Dsp_default_scale;

extern long  Dsp_grey25;
extern long  Dsp_grey50;
extern long  Dsp_grey75;
extern long  Dsp_white;
extern long  Dsp_black;

extern GC    Dspgc_clr;
extern GC    Dspgc_inv;
extern GC    Dspgc_dbl;
extern GC    Dspgc_25;
extern GC    Dspgc_50;
extern GC    Dspgc_75;
extern GC    Dspgc;

#endif /*_dsp_c*/

void  Dsp_open();
void  Dsp_create_gcs();
int   Dsp_check_scale();
int   Dsp_load_font();

#endif /* _Dsp_h */
