/* 
 * x-tlk Toolkit - Copyright (c) Holger Pfaff
 * http://pfaff.dnsalias.net
 *
 * This software maybe used for any purpose provided the
 * above copyright notice is retained. It is supplied as is.
 * No warranty expressed or implied - Use at your own risk.
 */

#ifndef _Lst_h
#define _Lst_h

#ifdef _Lst_c

Time Lst_time = 0;

#define LST_CHARCNT 50

char Lst_char[LST_CHARCNT];
int  Lst_charcnt = 0;
int  Lst_decoration = FALSE;
Lst  Lst_cur;              /* Current selected Lst */

char *lst_mnu[] = 
{
   "sort",
   "sort rev",
   "redisplay",
   "deselect",
   0 
};

#endif /* _Lst_c */

Lst  Lst_create();        /* Create a list */
void Lst_mnu_proc();      /* notify-proc for menu events */
void Lst_dsp();           /* redisplay all text with pos-correction */
void Lst_updn();          /* scroll n-rows with border checking  */
void Lst_reset();         /* set lst to empty  */
void Lst_scb();           /* notify-proc for scrollbar */
void Lst_key_press();     /* notify-proc for keyboard events */
void Lst_button_press();  /* notify-proc for mouse events */
void Lst_hilite();        /* hilite row and deselect old row */
void Lst_sortparms();     /* set sortparameter */

/* #defines from Tlk.h 
 *
 * Lst_sort()             * sort lst according to sortparams *
 * Lst_append_mnu()       * Append item to lst_mnu *
 * Lst_delete()           * delete n-th entry *
 * Lst_insert()           * insert an item *
 * Lst_replace()           * insert/replace an item *
 * Lst_get()              * get n-th entry *
 * Lst_redisp()           * clears win an redisp *
 * Lst_cnt()              * returns no. of items *
 * Lst_sel()              * returns no. of selected items *
 *
 */
#endif /* _Lst_h */
