/* 
 * x-tlk Toolkit - Copyright (c) Holger Pfaff
 * http://pfaff.dnsalias.net
 *
 * This software maybe used for any purpose provided the
 * above copyright notice is retained. It is supplied as is.
 * No warranty expressed or implied - Use at your own risk.
 */

#include <tlk.h>

Win	win;
Lst     lst;
Mnu     mnu,smnu;
Txt     txt;

void timeproc() {
  long l;
  struct tm *z;
  time(&l);
  z = localtime(&l);
  sprintf(Win_io, "%02d:%02d:%02d", z->tm_hour, z->tm_min, z->tm_sec);
  Tlk_set(txt, TLK_SET_TXT, Win_io);
}

void callback(Win w, char *l) {
  Win_alarm("But1", "But2", "But3", "Headline", "Line1", "Line2", l, "Line4", "Line5");
}

int main(int argc, char **argv) {
  char *smnui[] = {"11111","22222","33333","44444","55555", NULL};

  Dsp_open(&argc, argv, "TST");

  win = Win_create(NULL, WIN_BAS_WIN, 0, 0, 9, 77, DSP_DEFAULT_SCALE, NULL, "TST", NULL);

  But_create(win, 1, 1, "Button", NULL, callback);
  smnu = Mnu_create(smnui, 3, DSP_DEFAULT_SCALE, "Three");
  mnu = Mnu_create(NULL, 0, DSP_DEFAULT_SCALE, "Menu title");
  Mnu_append_item(mnu, "Menu entry 1", NULL);
  Mnu_append_item(mnu, "Menu entry 22", smnu);
  Mnu_append_item(mnu, "Menu entry 333", NULL);

  But_create(win, 3, 1, "Menubutton", mnu, callback);

  Win_ds(win, Dspgc, 1, 25, 0, 0, "Label");
  Win_bs(win, Dspgc, 3, 25, 0, 0, "Bold Label");
  Win_bs(win, Dspgc_75, 5, 25, 0, 0, "Inactive Label");

  txt = Txt_create(win, 7, 25, 8, TXT_RO_NUM, NULL, NULL, NULL);
  Win_set_itimer(2000, 1000, timeproc);

  Win_bs(win, Dspgc, 5, 1, 0, 0, "  Alpha:");
  Win_ds(win, Dspgc, 7, 1, 0, 0, "Numeric:");
  Txt_create(win, 5, 10, 11, TXT_RW_ALPHA, smnu, NULL, NULL);
  Txt_create(win, 7, 10, 11, TXT_RW_NUM, NULL, NULL, NULL);
  Win_db(win, Dspgc, 5, 10, 1, 11, 0, 0);
  Win_db(win, Dspgc_75, 7, 10, 1, 11, 0, 0);

  lst = Lst_create(win, 1, 44, 6, 10, NULL, "List");
  Lst_insert(lst, "1");
  Lst_insert(lst, "22");
  Lst_insert(lst, "333");
  Lst_insert(lst, "4444");
  Lst_insert(lst, "55555");
  Lst_insert(lst, "666666");
  Lst_insert(lst, "7777777");
  Lst_insert(lst, "88888888");
  Lst_insert(lst, "999999999");
  Lst_insert(lst, "0000000000");
  Lst_insert(lst, "aaaaaaaaaa");
  Lst_insert(lst, "cccccccccc");
  Lst_insert(lst, "##########");

  Win_fb(win, Dspgc_25, 2, 63, 2, 5, 0,-2);
  Win_fb(win, Dspgc_75, 4, 63, 2, 5, 0, 0);
  Win_fb(win, Dspgc,    6, 63, 2, 5, 0, 2);

  Win_db(win, Dspgc_25, 2, 71, 2, 5, 0,-2);
  Win_db(win, Dspgc_75, 4, 71, 2, 5, 0, 0);
  Win_db(win, Dspgc,    6, 71, 2, 5, 0, 2);

  Win_loop(win);
  exit(0);
}
