/* 
 * x-tlk Toolkit - Copyright (c) Holger Pfaff
 * http://pfaff.dnsalias.net
 *
 * This software maybe used for any purpose provided the
 * above copyright notice is retained. It is supplied as is.
 * No warranty expressed or implied - Use at your own risk.
 */

#ifndef _Win_h
#define _Win_h

#define WIN_FACTOR            100
#define WIN_IO_BUFSIZE        4096
#define WIN_LABEL_LEN         9

#define WIN_ALARM_WIDTH       56
#define WIN_ALARM_HEIGTH      12
#define WIN_ALARM_EMPTY       "          "
#define WIN_ALARM_BUT_WIDTH  (strlen(WIN_ALARM_EMPTY) + 2)
#define WIN_ALARM_HL_ROW      1   
#define WIN_ALARM_FIRST_ROW   4   
#define WIN_ALARM_BUT_ROW     10   
#define WIN_ALARM_BUT_COL(i) (WIN_ALARM_WIDTH/4 * (i+1) - WIN_ALARM_BUT_WIDTH/2)
#define WIN_ALARM_BUT(col)  ((col + 7) / (WIN_ALARM_WIDTH/4))

#ifdef _Win_c

char *Win_io;
char *Win_uml;
char *Win_buf;
char *Win_label;
 
Win   Wins[WIN_FACTOR];
Win   Win_last[WIN_FACTOR];
Win   Win_c;
Win   Win_alarm_buts[3];
Win   Win_alarm_win    = NULL;
int   Win_alarm_active = FALSE;
int   Win_lock         = TRUE;
int   Win_alarm_reload = 0;
int   Win_alarm_init   = 0;
int   Win_iconic       = FALSE;
int   Win_x            = -1;
int   Win_y            = -1;
int   Win_ix           = -1;
int   Win_iy           = -1;
int   Win_w            =  0;
int   Win_h            =  0;
int   Win_lastx;
int   Win_lasty;

Atom  Win_atoms[3];


Win_alarm_but_t   Win_alarm_but = WIN_ALARM_NO_BUT;
Win_alarm_but_t   Win_alarm();

void   (*Win_clock_proc)();
void   (*Win_middle_proc)();

static unsigned char Win_stop_bits[] = {
   0x00, 0xfe, 0x00, 0x00, 0x80, 0xff, 0x03, 0x00, 0xe0, 0xff, 0x0f, 0x00,
   0xf0, 0xff, 0x1f, 0x00, 0xf8, 0x83, 0x3f, 0x00, 0xfc, 0x19, 0x7f, 0x00,
   0xfc, 0x38, 0x7e, 0x00, 0xfe, 0x38, 0xfe, 0x00, 0xfe, 0x3d, 0xfe, 0x00,
   0xff, 0x1f, 0xfe, 0x01, 0xff, 0x0f, 0xff, 0x01, 0xff, 0x8f, 0xff, 0x01,
   0xff, 0xc7, 0xff, 0x01, 0xff, 0xe7, 0xff, 0x01, 0xff, 0xe7, 0xff, 0x01,
   0xff, 0xff, 0xff, 0x01, 0xfe, 0xff, 0xff, 0x00, 0xfe, 0xe7, 0xff, 0x00,
   0xfc, 0xc3, 0x7f, 0x00, 0xfc, 0xc3, 0x7f, 0x00, 0xf8, 0xe7, 0x3f, 0x00,
   0xf0, 0xff, 0x1f, 0x00, 0xe0, 0xff, 0x0f, 0x00, 0x80, 0xff, 0x03, 0x00,
   0x00, 0xfe, 0x00, 0x00};
   
Pixmap Win_stop_pix;

extern void Win_enable_timer();
extern void Win_disable_timer();

#else

extern Win   Win_c;
extern char *Win_io;
extern char *Win_uml;
extern char *Win_buf;
extern char *Win_label;

extern int   Win_iconic;
extern int   Win_x;
extern int   Win_y;
extern int   Win_ix;
extern int   Win_iy;
extern int   Win_w;
extern int   Win_h;
extern int   Win_lastx;
extern int   Win_lasty;

extern void (*Win_clock_proc)();
extern void (*Win_middle_proc)();
extern void Win_enable_timer();
extern void Win_disable_timer();


#endif

void *Win_malloc();
void *Win_realloc();
 
void  Win_init();
void  Win_exit();
void  Win_quit();
int   Win_error();

void  Win_alarm_proc();
void  Win_alarm_create_win();

void  Win_set_itimer();
void  Win_alarm_clock();
void  Win_sleep();

void  Win_enter_leave();
void  Win_button_press();
void  Win_button_release();
void  Win_event();
int   Win_events();

Win   Win_create();
void  Win_loop();
void  Win_3d();
void  Win_text();
void  Win_draw();
void  Win_dl();
void  Win_db();
void  Win_fb();
void  Win_dt();
void  Win_bt();
void  Win_ft();
void  Win_ds();
void  Win_bs();
void  Win_fs();

#endif /* _Win_h */
